//+------------------------------------------------------------------+
//|                                               Stochastic RSI.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                   Stochastic RSI |
//|                                                                  |
//|added arrows and lines      deVries                               |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers    2
#property indicator_color1     Gold
#property indicator_color2     Red
#property indicator_width1     2
#property indicator_style2     STYLE_DASH
#property indicator_levelcolor Green

//-----
extern int    RsiPeriod                 = 14;//8;
extern int    Price                     = PRICE_CLOSE;
extern int    StochasticKPeriod         = 14;//8;
extern int    StochasticSlowing         = 3;
extern int    StochasticSlowingMaMethod = MODE_EMA;
extern int    StochasticDPeriod         = 3;//8;
extern int    StochasticDMaMethod       = MODE_EMA;
extern double levelOs                   = 20;
extern double levelOb                   = 80; 

extern string note                      = "turn on Alert = true; turn off = false";
extern bool   alertsOn                  = true;
extern bool   alertsOnCurrent           = true;
extern bool   alertsMessage             = true;
extern bool   alertsSound               = true;
extern bool   alertsEmail               = false;
extern string soundfile                 = "alert2.wav";
//-----
extern bool      showArrows    = true;
extern color     ArrowUpRevClr = Lime;
extern color     ArrowDnRevClr = Red;
extern int       ArrowRevSize  =  0;
extern color     ArrowUpClr = Lime;
extern color     ArrowDnClr = Red;
extern int       ArrowSize  = 2;
//-----
extern int       AddSigScreans  = 1;

double stochRsi[];
double stochRsiSignal[];
double rsi[];
double stoch[];
double trend[];

int      maxArrows;
int      SignalGap;
string   SignalName;
bool     drawoversold=false,drawoverbought=false;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);
   SetIndexBuffer(0,stochRsi);
   SetIndexBuffer(1,stochRsiSignal);
   SetIndexBuffer(2,rsi);
   SetIndexBuffer(3,stoch);
   SetIndexBuffer(4,trend);
   SetLevelValue(0,levelOs);
   SetLevelValue(1,levelOb);
   SetLevelValue(2,5);
   SetLevelValue(3,50);
   SetLevelValue(4,95);
//-----
   string smooth1 = getAverageName(StochasticSlowingMaMethod);
   string smooth2 = getAverageName(StochasticDMaMethod);            
   IndicatorShortName("StochRsi ("+RsiPeriod+","+StochasticKPeriod+","+StochasticSlowing+","+smooth1+","+StochasticDPeriod+","+smooth2+")");
//-----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit() 
 {
//----
   int i, ot=ObjectsTotal()-1;
   string id;
//----
   for(i=ot;i>=0;i--)
    {id=ObjectName(i);
     if((StringSubstr(id,0,12)=="StochRSILine")||(StringSubstr(id,0,11)=="StochRSIDot"))
      {ObjectDelete(id);}      
    }
   return(0);   
 }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int i,limit;
//----
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
     limit=MathMin(Bars-counted_bars,Bars-1);
//----   
   for(i=limit; i>=0; i--)
      {
       rsi[i] = iRsi(iMA(NULL,0,1,0,MODE_SMA,Price,i),RsiPeriod,i);
       double min = rsi[ArrayMinimum(rsi,StochasticKPeriod,i)];
       double max = rsi[ArrayMaximum(rsi,StochasticKPeriod,i)];
       stoch[i] = 0.5; if (min!=max) stoch[i] = 100.0*(rsi[i]-min)/(max-min); 
       stochRsi[i] = iCMAOnArray(stoch,stochRsi,StochasticSlowing,StochasticSlowingMaMethod,i);
       stochRsiSignal[i] = iCMAOnArray(stochRsi,stochRsiSignal,StochasticDPeriod,StochasticDMaMethod,i); 
       trend[i] = trend[i+1]; 
       if (stochRsi[i] <= levelOs && stochRsi[i] > stochRsi[i+1] && stochRsi[i+1] < stochRsi[i+2]) trend[i] =  1;
       if (stochRsi[i] >= levelOb && stochRsi[i] < stochRsi[i+1] && stochRsi[i+1] > stochRsi[i+2]) trend[i] = -1;
      }
                 
  if(alertsOn)
     {
      if (alertsOnCurrent)
         int whichBar = 0;
         else     whichBar = 1;

      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
        doAlert(" over sold Valley");
        else  doAlert(" over bought Peak");       
     }
     

   SignalGap = MathCeil(iATR(NULL,0,50,0)/Point);
   if (showArrows)
      {    
       if(stochRsi[1]< 5){DrawDot(High[1]+(SignalGap*Point),ArrowUpRevClr,218,Time[1],ArrowRevSize);}
       if(stochRsi[0]>levelOs && stochRsi[1]<levelOs && !drawoversold)DrawDot(High[0]+(SignalGap*Point*1.5),ArrowUpClr,233,Time[0],ArrowSize);
       if(stochRsi[1]>95)DrawDot(Low[1]-(SignalGap*Point/4),ArrowDnRevClr,217,Time[1],ArrowRevSize);               
       if(stochRsi[0]<levelOb && stochRsi[1]>levelOb && !drawoverbought)DrawDot(Low[0]-(SignalGap*Point/4),ArrowDnClr,234,Time[0],ArrowSize);
      }
 
      
                     
   if (stochRsi[0]>35)drawoversold=true;
   if (stochRsi[0]< 5 && stochRsi[1]>5 && drawoversold==true)
        {
         DrawVline(Red, Time[0]);     
         drawoversold =false;
        }
   if (stochRsi[0]<65)drawoverbought=true;
   if (stochRsi[0]> 95 && stochRsi[1]< 95 && drawoverbought==true)
        {
         DrawVline(Blue, Time[0]);     
         drawoverbought =false;
        }
        
                 
   return(0);           
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

 

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," stochrsi ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," stochrsi "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}
//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
double workRsi[][3];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int shift, int forz=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int    z     = forz*3; 
      int    i     = Bars-shift-1;
      double alpha = 1.0/period; 


   workRsi[i][_price+z] = price;
   if (i<period)
      {
         int k; double sum = 0; for (k=0; k<period && (i-k-1)>=0; k++) sum += MathAbs(workRsi[i-k][_price+z]-workRsi[i-k-1][_price+z]);
            workRsi[i][_change+z] = (workRsi[i][_price+z]-workRsi[0][_price+z])/MathMax(k,1);
            workRsi[i][_changa+z] =                                         sum/MathMax(k,1);
      }
   else
      {
         double change = workRsi[i][_price+z]-workRsi[i-1][_price+z];
                         workRsi[i][_change+z] = workRsi[i-1][_change+z] + alpha*(        change  - workRsi[i-1][_change+z]);
                         workRsi[i][_changa+z] = workRsi[i-1][_changa+z] + alpha*(MathAbs(change) - workRsi[i-1][_changa+z]);
      }
   if (workRsi[i][_changa+z] != 0)
         return(50.0*(workRsi[i][_change+z]/workRsi[i][_changa+z]+1));
   else  return(0);
}


double iCMAOnArray(double& source[], double& result[], int period, int method, int i)
{
   switch(method)
   {
      case 0: return(iSmaOnArray(source,period,i));
      case 1: return(iEmaOnArray(source,result,period,i));
      case 2: return(iSmmaOnArray(source,result,period,i));
      case 3: return(iLwmaOnArray(source,period,i));
      case 4: return(iTmaOnArray(source,period,i));
      case 5: return(iSineWMAOnArray(source,period,i));
      case 6: return(iVolumeWMAOnArray(source,period,i));
      case 7: return(iEPMAOnArray(source,period,i));
   }
   return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double iSmaOnArray(double& array[], double period, int i)
{
   double sum = 0; 
   for(int k=0; k<period && (i+k)<Bars; k++) sum += array[i+k];  
   if (k!=0)
         return(sum/k);
   else  return(EMPTY_VALUE);
}



double iEmaOnArray(double& source[], double& result[], double period, int i)
{
   double alpha = 2.0 / (1.0+period);
          result[i] = result[i+1]+alpha*(source[i]-result[i+1]);
   return(result[i]);
}

double iSmmaOnArray(double& source[], double& result[], double period, int i)
{
   if (i>=(Bars-period))
   {
      double sum = 0; 
         for(int k=0; k<period && (i+k)<Bars; k++) sum += source[i+k];  
         if (k!=0)
               result[i] = sum/k;
         else  result[i] = EMPTY_VALUE;
   }      
   else   result[i] = (result[i+1]*(period-1)+source[i])/period;
   return(result[i]);
}



double iLwmaOnArray(double& array[], double period, int i)
{
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}



double iTmaOnArray(double& array[], double period, int i)
{
   double half = (period+1.0)/2.0;
   double sum  = 0;
   double sumw = 0;

   for(int k=0; k<period && (i+k)<Bars; k++)
   {
      double weight = k+1; if (weight > half) weight = period-k;
             sumw  += weight;
             sum   += weight*array[i+k];  
   }             
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}



#define Pi 3.14159265358979323846
double iSineWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = MathSin(Pi*(k+1)/(period+1));
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}


double iVolumeWMAOnArray(double& array[], int period, int i)
{
   double sum  = 0;
   double sumw = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
      double weight = Volume[i+k];
             sumw  += weight;
             sum   += weight*array[i+k]; 
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}


double iEPMAOnArray(double& array[], int period, int i)
{
   double weight = 2.0*period-1.0;
   double sum    = 0;
   double sumw   = 0;
  
   for(int k=0; k<period && (i+k)<Bars; k++)
   { 
       sumw   += weight;
       sum    += weight*array[i+k]; 
       weight -= 3;
   }
   if (sumw!=0)
         return(sum/sumw);
   else  return(EMPTY_VALUE);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+


string methodNames[] = {"SMA","EMA","SMMA","LWMA","TriMA","SWMA","VWMA","EPMA"};
string getAverageName(int& method)
{
   method=MathMax(MathMin(method,7),0); return(methodNames[method]);
}

//-----------------------------------------------------------
void DrawVline (color Color, datetime time)   
   {//Use: DrawVline(Yellow, Time[i]);   
    static int cntr1;
    static double PrevVlineTime;   
    if (time == PrevVlineTime) return;//Still on same bar      
    ObjectCreate("StochRSILine"+cntr1, OBJ_VLINE, 0, time, 0);      
    ObjectSet("StochRSILine"+cntr1, OBJPROP_COLOR, Color);
    ObjectSet("StochRSILine"+cntr1, OBJPROP_BACK,true);      
    cntr1++;
    PrevVlineTime = time;//Store bar time of last drawn line   
    return;
   }     
//----------------------------------------------------------- 
//+------------------------------------------------------------------+
void DrawDot(double LinePrice,color LineColor,int arrowcode,datetime time,int Arrowsize)
   {//Use: DrawDot(
    static int cntr2;
    static double PrevDotTime; 
    if (time == PrevDotTime) return;//Still on same bar 
    ObjectCreate("StochRSIDot"+cntr2, OBJ_ARROW, 0, time, LinePrice); 
    ObjectSet("StochRSIDot"+cntr2, OBJPROP_COLOR, LineColor);
    ObjectSet("StochRSIDot"+cntr2, OBJPROP_ARROWCODE, arrowcode);
    ObjectSet("StochRSIDot"+cntr2, OBJPROP_WIDTH,Arrowsize);
    cntr2++;
    PrevDotTime = time;//Store bar time of last drawn line  
    return;
   } 
//+------------------------------------------------------------------+  